<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Car ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Car extends AbstractStructArrayBase
{
    /**
     * The Rentacar
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Car[]
     */
    public $Rentacar;
    /**
     * Constructor method for ArrayOfJP_Car
     * @uses ArrayOfJP_Car::setRentacar()
     * @param \StructType\JP_Car[] $rentacar
     */
    public function __construct(array $rentacar = array())
    {
        $this
            ->setRentacar($rentacar);
    }
    /**
     * Get Rentacar value
     * @return \StructType\JP_Car[]|null
     */
    public function getRentacar()
    {
        return $this->Rentacar;
    }
    /**
     * This method is responsible for validating the values passed to the setRentacar method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRentacar method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRentacarForArrayConstraintsFromSetRentacar(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_CarRentacarItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CarRentacarItem instanceof \StructType\JP_Car) {
                $invalidValues[] = is_object($arrayOfJP_CarRentacarItem) ? get_class($arrayOfJP_CarRentacarItem) : sprintf('%s(%s)', gettype($arrayOfJP_CarRentacarItem), var_export($arrayOfJP_CarRentacarItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Rentacar property can only contain items of type \StructType\JP_Car, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Rentacar value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Car[] $rentacar
     * @return \ArrayType\ArrayOfJP_Car
     */
    public function setRentacar(array $rentacar = array())
    {
        // validation for constraint: array
        if ('' !== ($rentacarArrayErrorMessage = self::validateRentacarForArrayConstraintsFromSetRentacar($rentacar))) {
            throw new \InvalidArgumentException($rentacarArrayErrorMessage, __LINE__);
        }
        $this->Rentacar = $rentacar;
        return $this;
    }
    /**
     * Add item to Rentacar value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Car $item
     * @return \ArrayType\ArrayOfJP_Car
     */
    public function addToRentacar(\StructType\JP_Car $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Car) {
            throw new \InvalidArgumentException(sprintf('The Rentacar property can only contain items of type \StructType\JP_Car, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Rentacar[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Car|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Car|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Car|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Car|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Car|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Rentacar
     */
    public function getAttributeName()
    {
        return 'Rentacar';
    }
}
